package ass.excercises.cvi7.demo4;

import io.reactivex.netty.protocol.http.server.HttpServer;
import io.reactivex.netty.protocol.http.server.HttpServerBuilder;
import io.reactivex.schedulers.Schedulers;

import java.io.IOException;
import java.io.UncheckedIOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.stream.Stream;

import javaslang.Tuple;


public class DynamicServerNoAjax {
	
	private static SlowRandomServiceObs randServiceObs = new SlowRandomServiceObs();
	
	private static String IMG_LOADING = "<img width=\"128px\" src=\"http://www.cuisson.co.uk/templates/cuisson/supersize/slideshow/img/progress.BAK-FOURTH.gif\">";
	
	public static void main(String[] args) {
		//ExamplesEnvironment env = ExamplesEnvironment.newEnvironment(HelloWorldServer.class);

		HttpServer<String, String> server = new HttpServerBuilder<String, String>(ServerConfig.SERVER_PORT, 
        		(req, resp) -> {
        			resp.writeAndFlush("<h1>No ajax demo</h1>");
        			Stream.of("randAlpha", "randAlphaNum", "randNum").forEach(id -> 
        				resp.writeAndFlush("<div id='"+id+"'>"+IMG_LOADING+"</div>")
        			);
        			
        			io.reactivex.Observable.just("randAlpha", "randAlphaNum", "randNum")
        			.flatMap(id -> 
        				randServiceObs.getRandom(id)
        				.map(result -> Tuple.of(id, result))
        				.subscribeOn(Schedulers.io())
        			)
        			.observeOn(Schedulers.single())
        			.forEach(tuple -> 
        				resp.writeAndFlush("<script>document.querySelector('#"+tuple._1+"').innerHTML = '"+tuple._2+"';</script>")
        			);
        			
        			return resp.writeAndFlush("<footer><hr>done</footer>");
        		}
        ).build();

		server.startAndWait();
	}
	
	private static byte[] readFile(String filepath) {
		filepath = "document_root/" + filepath.replace("/", "");
		System.out.println("Requesting: '"+filepath+"'");
		try {
			return Files.readAllBytes(Paths.get(filepath));
		}catch(IOException ioe) {
			throw new UncheckedIOException(ioe);
		}
	}
	
}
