package ass.excercises.cvi7.demo2;

import java.util.stream.Stream;

public class Replacement {
	
	public static void main(String[] args) {
		String input = "(a b c !)";
		System.out.println("Input: " + input);
		elaborateReplacement(input);
		functionalReplacement(input);
		regExReplacement(input);
	}
	
	// An example of "dad" approach to replacement
	public static String elaborateReplacement(String input) {
		return input
				.replace("(", "")
				.replace(" ", "")
				.replace("!", "")
				.replace(")", "");
	}

	// example of functional approach (just to show how reduce can be exploited to get mutation)
	public static void functionalReplacement(String input) {
		String wordWithReplacements = Stream.of(" ", "(", ")", "!")
		.reduce(input, (word, b) -> word.replace(b, ""));
		
		System.out.println("Func. replacement: " + wordWithReplacements);
	}
	
	// concise ideal  
	public static void regExReplacement(String input) {
		System.out.println("RegEx replacement: " + input.replaceAll("[\\s()!]+", ""));
		
		// one can say that all characters but "a-z" should be removed by prependeing "^" character
		System.out.println("RegEx replacement 2: " + input.replaceAll("[^a-z]+", ""));
	}
	
}
